:" VMH - Vim Mail Handler
:" New versions available at http://www.fleiner.com/vmh/
:" Send emails regarding this code to vmh@fleiner.com
:"
:" Distributed in the hope that it is useful
:"
:" Copyright (C) 1998  Claudio Fleiner <claudio@fleiner.com>
:"
:" WARNING: this is work in progress, it is not yet complete, has several
:" bugs and, if you use it, can make you lose emails, send emails to
:" the wrong people and upset your sysadmin. US IT AT YOUR OWN RISK
:"
:" See the file README for further details

:se lazyredraw
:se hidden
:se cpt=k../.vmh_dirs
:let g:vmh_dir=0
:let g:vmh_mail=0
:se verbose=0

:function GetAddress()
:   let line=matchstr(getline(".").":","[^:]*")
:   if(match(line," \+$")>0) 
:      let line=strpart(line,0,match(line," \+$"))
:   endif
:   return line
:endfunction

:function InsertEmail() 
:   let l=getline(".")
:   if(match(l,": $")>=0)
:      call setline(line("."),l.@@)
:   else
:      call setline(line("."),l.", ".@@)
:   endif
:endfunction

:function! GetEmail()
:   let $line=getline(".")
:   let $pos=col(".")
:   let $m="[:,] *"
:   if(match($line,"^ \\+")==0) 
:      let $line=strpart($line,matchend($line,"^ \\+"),999)
:   endif
:   while(matchend($line,$m)>=0 && matchend($line,$m)<$pos) 
:      let $line=strpart($line,matchend($line,$m),999)
:   endwhile
:   if(match($line,$m)>=0)
:      let $line=strpart($line,0,match($line,$m))
:   endif
:   let @@=$line
:   return $line
:endfunction

:function Resend() 
:  let $EMAIL=input("Enter email address to resend: ")
:  if $EMAIL != ""
:     exe "w !/usr/lib/sendmail -i ".$EMAIL
:  endif
:endfunction


:function AddFortune(name)
:  /^-- -- -- -- --$/,/^------/-1d
:  /^-------/i
-- -- -- -- --

.
:  exe "/^------/-1!/usr/games/fortune ".a:name
:endfunction

:function SetCurrentMail()
:  normal 0mvr>
:  %s/^>/ /g
:  normal 'v0r>
:  nohlsearch
:endfunction

:function CreateMime()
:  1,/^$/g/^Content-Type: /d m
:  1,/^$/g/^Content-Transfer-Encoding: /d n
:  exe "normal 1G/^$\<cr>"
:  .,$y
:  .,$d
:  r drafts/mime.top
:  ?^--
:  exe "normal \"mP\"npp"
:  /--RANDOM--
:  a

.
:  .!head -c 33 /dev/urandom | mimencode | sed 's/\///g'
:  let $r=getline(".")
:  normal dd
:  echo $r."\n"
:  exe "%s/--RANDOM--/".$r."/g"
:endfunction

:function! AddMime()
:  let $file=input("filename: ")
:  echo "\nt=text t6=text64 tq=textqp\nh=html h6=html64 hq=htmlqp\na=application j=jpeg g=gif p=ps"
:  let $mime=input("mime type: ")
:  let $encode="6"
:  if $mime == "t"
:     let $mime="text/plain; charset=iso-8859-1"
:     let $encode="n"
:  elseif $mime == "t6"
:     let $mime="text/plain; charset=iso-8859-1"
:  elseif $mime == "tq"
:     let $encode="q"
:     let $mime="text/plain; charset=iso-8859-1"
:  elseif $mime == "h"
:     let $mime="text/html; charset=iso-8859-1"
:     let $encode="n"
:  elseif $mime == "h6"
:     let $mime="text/html; charset=iso-8859-1"
:  elseif $mime == "hq"
:     let $encode="q"
:     let $mime="text/html; charset=iso-8859-1"
:  elseif $mime == "a"
:     let $mime="application/octet-stream"
:  elseif $mime == "j" 
:     let $mime="image/jpeg"
:  elseif $mime == "g"
:     let $mime="image/gif"
:  elseif $mime == "p"
:     let $mime="application/postscript"
:  endif
:  let $name=$file
:  if match($name,"/")>=0
:    let $name=matchstr($name,"[^/]*$")
:  endif
:  exe "normal 0G?--$\<cr>yyP$xx"
:  let @@="Content-Type: ".$mime."; name=\"".$name."\"\n"
:  normal p
:  let @@="Content-Disposition: attachment; filename=\"".$name."\"\n"
:  normal p
:  if $encode == "6"
:    let @@="Content-Transfer-Encoding: base64\n"
:    normal p
:  elseif $encode == "q"
:    let @@="Content-Transfer-Encoding: quoted-printable\n"
:    normal p
:  end
:  a

.
:  if $encode == "6"
:     r !mimencode $file
:  elseif $encode == "q"
:     r !mimencode -q $file
:  else
:     r $file
:  endif
:endfunction

:function! GetMimeHeader()
:  ?^--
:  let b:div=getline(".")
:  let b:lp=line(".")
:  let b:type="text/plain"
:  let b:enc="none"
:  let b:filename=""
:  while(getline(b:lp) !=# "") 
:     if(match(getline(b:lp),"Content-[tT]ype: ")>=0)
:        let b:type=getline(b:lp)
:     elseif(match(getline(b:lp),"Content-[tT]ransfer-[eE]ncoding")>=0)
:        let b:enc=getline(b:lp)
:     elseif(match(getline(b:lp),"name=\"")>=0)
:        let b:filename=strpart(matchstr(getline(b:lp),"name=\"[^\"]*"),6,999)
:     endif
:     let b:lp=b:lp+1
:  endwhile
:  /^$
:endfunction

:function! DeleteMime()
:  ?^--
:  let b:div=getline(".")
:  exe "normal V/^".b:div."\<cr>kd"
:endfunction

:" zt : decode to text (html --> text with lynx)
:" zf : store to file after decoding
:" zx : show with xv
:" zg : show with gimp
:" zn : show with netscape
:" zp : show with more (print to screen)
:function! DecodeMime(cmd)
:   let r=GetMimeHeader()
:   exe "normal jV/^".b:div."\<cr>kk"
:   if(match(b:enc,"base64")>=0)
:     let dcmd="mimencode -u"
:   elseif(match(b:enc,"quoted-printable")>=0) 
:     let dcmd="mimencode -q -u"
:   else
:     let dcmd="cat"
:   endif
:
:   if(a:cmd == "") 
:      if(match(b:type,"html")>=0)
:         let tmpfile = tempname().".html"
:         exe "normal !".dcmd." > ".tmpfile."\<cr>"
:         exe "normal !!lynx -dump ".tmpfile."\<cr>"
:         exe ":!rm ".tmpfile
:      else
:         exe "normal !".dcmd."\<cr>"
:      endif
:      ?^--
:      exe "normal /^".b:type."\<cr>"
:      s/[^ \/]*\/[^ ;\t"]*/text\/plain/
:      if b:enc != "none"
:         ?^--
:         exe "normal /^".b:enc."\<cr>"
:         s/: .*/: 8bit/
:      endif
:   elseif(a:cmd == "more")
:      :'<,'>w !dcmd | more
:   elseif(a:cmd == "netscape")
:      let tmpfile = tempname().".html"
:      exe "normal :w !".dcmd." > ".tmpfile."\<cr>"
:      exe ":!(netscape -remote file:".tmpfile." ; sleep 10 ; rm ".tmpfile." )&"
:   elseif(a:cmd == "lynx")
:      let tmpfile = tempname()
:      exe "normal :w !".dcmd." > ".tmpfile."\<cr>"
:      exe ":!lynx ".tmpfile." ; rm ".tmpfile
:   elseif(a:cmd == "gimp")
:      let tmpfile = tempname()
:      exe "normal :w !".dcmd." > ".tmpfile."\<cr>"
:      exe ":!(gimp ".tmpfile." ; rm ".tmpfile." )&"
:   elseif(a:cmd == "xv")
:      let tmpfile = tempname()
:      exe "normal :w !".dcmd." > ".tmpfile."\<cr>"
:      exe "!(xv ".tmpfile." ; rm ".tmpfile." )&"
:   endif
:   exe "normal \<esc>"
:endfunction
     
:function! StoreMime()
:   let r=GetMimeHeader()
:   exe "normal jV/^".b:div."\<cr>kk"
:   if(match(b:enc,"base64")>=0)
:     let dcmd="mimencode -u"
:   elseif(match(b:enc,"quoted-printable")>=0) 
:     let dcmd="mimencode -q -u"
:   else
:     let dcmd="cat"
:   endif
:   let name=input("Enter filename [".b:filename."]: ")
:   if name == ""
:      let name=b:filename
:   endif
:   echo "\n"
:   exe ":'<,'>w !".dcmd." > ".name
:   exe "normal \<esc>"
:endfunction



:function ReadMail()
:  set shm+=O
:  let wh=winheight(0)
:  perl { &getdirname(); }
:  exe "normal 0/[0-9]\<cr>yw:w\<cr>\<c-w>j"
:  if &modified == 1
:    w
:  endif
:  bd
:  exe "normal \<c-w>k"
:  sp
:  exe "normal \<c-w>x".wh."\<c-w>_\<c-w>j"
:  exe "e ".dirname."/".@@
:  /^\([Ff]rom\|[Ss]ubject\|[Tt]o\):
:  exe "normal z\<cr>"
:  nohlsearch
:  set shm-=O
:endfunction

:function EnterVmhCache()
:   nmap <CR>   :let r=SetCurrentMail()+ReadMail()<CR>
:   nmap <ESC>j /^><CR>0j<CR>
:   nmap <ESC>n /^><CR>0j/>$<CR><CR>
:   nmap <ESC>k /^><CR>0k<CR>
:   nmap <ESC>p /^><CR>0?>$<CR><CR>
:   nmap <ESC>d :s/>[^>]*$/>D/<CR><esc>n
:   vmap <ESC>d :s/>[^>]*$/>D/<CR><esc>n
:   nmap <ESC>g :w<cr>:let g:vmh_dir=2<cr>mv:bu 2<cr>/^
:   nmap <ESC>m :w<cr>:let g:vmh_dir=1<cr>mv:bu 2<cr>
:   nmap <ESC>c :w<CR>:perl { &commit(); }<CR>:e<CR>
:   nmap <ESC>e :perl { &newemail(); }<CR><C-W>j:exec("split drafts/".vmh_newemail)<CR>:r drafts/default<CR>kdd/: *$<CR><C-W>x<C-W>j:w<CR><C-W>_A
:   nmap <ESC>r <cr><esc>r
:   nmap <ESC>f <cr><esc>f
:   nmap <ESC>w /^><CR>
:   nmap <ESC>s :w<CR>:perl { &commit();&packdir(); }<CR>:e<CR>
:   nmap <ESC>z<ESC>d :bu 2<cr>:perl { &scandirs();&readdirs(); }<CR>:e!<CR>:bu #<CR>
:   nmap <ESC>z<ESC>m <CR><esc>z<esc>m
:   nmap <ESC>z<ESC>s <CR><esc>z<esc>s
:   nmap <ESC>z<ESC>i :!inc<CR>:perl { &newdir("inbox"); }<CR>
:endfunction

:function ExitVmhCache()
:   nunmap <CR>
:   nunmap <ESC>j
:   nunmap <ESC>n
:   nunmap <ESC>k
:   nunmap <ESC>p
:   nunmap <ESC>d
:   vunmap <ESC>d
:   nunmap <ESC>g
:   nunmap <ESC>m
:   nunmap <ESC>c
:   nunmap <ESC>e
:   nunmap <ESC>r
:   nunmap <ESC>f
:   nunmap <ESC>w
:   nunmap <ESC>s
:   nunmap <ESC>z<ESC>d
:   nunmap <ESC>z<ESC>s
:   nunmap <ESC>z<ESC>m
:endfunction

:autocmd BufEnter .vmh_cache nested let r=EnterVmhCache()
:autocmd BufLeave .vmh_cache nested let r=ExitVmhCache()

:function EnterVimDir()
:   nmap <ESC>m 0"vy$:bu #<cr>'vAx<esc>F>C><esc>"vp0<esc>n
:   nmap <ESC>g 0"vy$:bu #<cr>:w<cr>:perl { &newdir("<C-R>v"); }<CR>
:   nmap <ESC>q :bu #<cr>
:   if g:vmh_dir == 1 | exec "nmap <CR> <ESC>m" | elseif g:vmh_dir == 2 | exec "nmap <CR> <ESC>g" | else | exec "nmap <CR> <CR>" | endif
:endfunction

:function ExitVimDir()
:  nunmap <ESC>m
:  nunmap <ESC>g
:  nunmap <ESC>q
:  nunmap <CR>
:endfunction

:autocmd BufEnter .vmh_dirs nested let r=EnterVimDir()
:autocmd BufLeave .vmh_dirs nested let r=ExitVimDir()


:function EnterAddress()
:   if g:vmh_mail == 1 | exec "nmap <CR> <ESC>q" | else | exec "nmap <CR> <ESC>i" | endif
:   nmap <ESC>q :w<cr>:bu #<cr>
:   nmap <ESC>i :let @@=GetAddress()<cr>:bu #<cr>:let r=InsertEmail()<cr>$
:   nmap <esc>s :%!sort<CR>
:endfunction

:function ExitAddress()
:   nunmap <CR>
:   nunmap <ESC>q
:   nunmap <ESC>i
:   nunmap <ESC>s
:endfunction

:autocmd BufEnter address nested let r=EnterAddress()
:autocmd BufLeave address nested let r=ExitAddress()


:function EnterDraft()
:   nmap <ESC>f<ESC>a :let r=AddFortune("all")<CR>
:   nmap <ESC>f<ESC>s :let r=AddFortune("-s")<CR>
:   nmap <ESC>x :w<CR>:perl { &sendemail(); }<CR>
:   nmap <ESC>z<ESC>m :let r=CreateMime()<cr>
:   nmap <ESC>z<ESC>a :let r=AddMime()<cr>
:   nmap <ESC>z<ESC>d :let r=DeleteMime()<cr>
:   nmap <ESC>a :let g:vmh_mail=2<cr>:w<cr>:bu 3<cr>
:   imap <ESC>a <esc>:let g:vmh_mail=2<cr>:w<cr>:bu 3<cr>
:   nmap <ESC>n /: $<CR>A
:   imap <ESC>n <esc>/: $<CR>A
:endfunction

:function ExitDraft()
:   nunmap <ESC>f<ESC>a
:   nunmap <ESC>f<ESC>s
:   nunmap <ESC>x
:   nunmap <ESC>a
:   iunmap <ESC>a
:   nunmap <ESC>z<ESC>m
:   nunmap <ESC>z<ESC>a
:   nunmap <ESC>z<ESC>d
:   iunmap <ESC>n
:   nunmap <ESC>n
:endfunction

:autocmd BufEnter draft.[0-9]* nested let r=EnterDraft()
:autocmd BufLeave draft.[0-9]* nested let r=ExitDraft()



:function EnterMail()
:   nmap <ESC>w <C-W>k<esc>w
:   nmap <ESC>j <C-W>k<ESC>j
:   nmap <ESC>k <C-W>k<ESC>k
:   nmap <ESC>n <C-W>k<ESC>n
:   nmap <ESC>p <C-W>k<ESC>p
:   nmap <ESC>d <C-W>k<ESC>d
:   nmap <ESC>m <C-W>k<ESC>m
:   nmap <ESC>g <C-W>k<ESC>g
:   nmap <ESC>e <C-W>k<ESC>e
:   nmap <ESC>c <C-W>k<ESC>c
:   nmap <ESC>s <C-W>k<ESC>s
:   nmap <ESC>a :let r=GetEmail()<cr>:let g:vmh_mail=1<cr>:w<cr>:bu 3<cr>O<esc>P
:   nmap <ESC>z<esc>i <C-W>k<ESC>z<esc>i
:   nmap <ESC>z<esc>f :let r=StoreMime()<CR>
:   nmap <ESC>z<esc>t :let r=DecodeMime("")<CR>
:   nmap <ESC>z<esc>x :let r=DecodeMime("xv")<CR>
:   nmap <ESC>z<esc>g :let r=DecodeMime("gimp")<CR>
:   nmap <ESC>z<esc>n :let r=DecodeMime("netscape")<CR>
:   nmap <ESC>z<esc>p :let r=DecodeMime("more")<CR>
:   nmap <ESC>z<esc>l :let r=DecodeMime("lynx")<CR>
:   nmap <ESC>z<esc>d :let r=DeleteMime()<CR>
:   nmap <ESC>r :perl { &replyemail(); }<CR>1G/^$<CR>j"vyG:exec("split drafts/".vmh_newemail)<CR>:r drafts/reply<CR>:se paste<CR>kdd/--BODY--<CR>jmv"vP:.,'v-1:s/^/> /<CR>?--BODY--<CR>dd/--TO--<CR>:let @v = vmh_to<CR>6c <C-R>v<ESC>/--CC--<CR>:let @v = vmh_cc<CR>6c <C-R>v<ESC>/--MSGID--<CR>:let @v = vmh_messageid<CR>9c <C-R>v<ESC>/--FROM--<CR>:let @v = vmh_from<CR>8c <C-R>v<ESC>/--DATE--<CR>:let @v = vmh_date<CR>8c <C-R>v<ESC>/--SUBJECT--<CR>:let @v = vmh_subject<CR>11c <C-R>v<ESC><C-W>x<C-W>j:w<CR>/^><CR><C-W>_:se nopaste<CR>
:   nmap <ESC>f :perl { &replyemail(); }<CR>1G"vyG:exec("split drafts/".vmh_newemail)<CR>:r drafts/forward<CR>:se paste<CR>kdd/--BODY--<CR>jmv"vP:.,/^$/g/^Received: /,/^[^ <TAB>]/-1d<CR>?--BODY--<CR>dd/--SUBJECT--<CR>:let @v = vmh_subject<CR>11c <C-R>v<ESC><C-W>x<C-W>j:w<CR>/^><CR><C-W>_1G/: *$<CR><C-W>_:se nopaste<CR>A
:   nmap <ESC>z<ESC>m :w !metamail<cr>
:   nmap <ESC>z<ESC>s :let r=Resend()<cr>
:endfunction

:function ExitMail()
:   nunmap <ESC>w
:   nunmap <ESC>j
:   nunmap <ESC>k
:   nunmap <ESC>n
:   nunmap <ESC>p
:   nunmap <ESC>d
:   nunmap <ESC>m
:   nunmap <ESC>g
:   nunmap <ESC>f
:   nunmap <ESC>e
:   nunmap <ESC>r
:   nunmap <ESC>c
:   nunmap <ESC>s
:   nunmap <ESC>z<esc>f
:   nunmap <ESC>z<esc>m
:   nunmap <ESC>z<esc>i
:   nunmap <ESC>z<esc>s
:   nunmap <ESC>z<esc>t
:   nunmap <ESC>z<esc>d
:   nunmap <ESC>z<esc>x
:   nunmap <ESC>z<esc>g
:   nunmap <ESC>z<esc>l
:   nunmap <ESC>z<esc>n
:   nunmap <ESC>z<esc>p
:endfunction

:autocmd BufEnter [0-9]* nested let r=EnterMail()
:autocmd BufLeave [0-9]* nested let r=ExitMail()



:function MailSyntaxColor()
:   if has("syntax")
:      syn clear
:      syn region mailHeader  start="^[A-Z][A-Za-z-]\+: [^ \t]" end="^$"me=e-1 contains=mailEmail,mailFrom,mailTo,mailCC,mailSubject
:      syn match mailEmail "<*[-0-9A-Za-z_!.%]\+@[-0-9A-Za-z.]\+>*"
:      syn match mailFrom "^From:.*" contains=ailEmail
:      syn match mailTo "^To:.*" contains=ailEmail
:      syn match mailCC "^Cc:.*" contains=ailEmail
:      syn match mailSubject "^Subject:.*" contains=mailEmail,nailHttp
:      syn match mailComment "^\s*>.*" contains=mailEmail,mailHttp
:      syn match mailSpecialComment "^[- \t]\+$" contains=mailEmail,nailHttp
:      syn match mailHttp "https\=:\S\+"
:    
:      if !exists("did_vmhmail_syntax_inits")
:        let did_vmhmail_syntax_inits = 1
:        hi link mailHeader PreCondit
:        hi link mailEmail String
:        hi link mailComment Comment
:        hi link mailSpecialComment SpecialComment
:        hi link mailFrom Structure
:        hi link mailCc Type
:        hi link mailTo Type
:        hi link mailSubject Debug
:        hi link mailHttp Constant
:      endif
:      let b:current_syntax = "vmh"
:   endif
:endfunction

:function VmhCacheSyntaxColor()
:   if has("syntax")
:      syn clear
:      syn match vmhMoved "^.*>..[^>]*$"
:      syn match vmhDeleted "^.*>\s*D$"
:      syn match vmhCurrent "^>.*"
:      syn match vmhNew "^\*.*"
:      syn match vmhResponse "`"
:      
:      if !exists("did_vmhcache_syntax_inits")
:        let did_vmhcache_syntax_inits = 1
:        hi link vmhCurrent Todo
:        hi link vmhDeleted PreProc
:        hi link vmhMoved Comment
:        hi link vmhNew Statement
:        hi link vmhResponse Constant
:      endif
:      let b:current_syntax = "vmh_cache"
:   endif
:endfunction


:if has("syntax")
:   au! BufNewFile,BufReadPost .vmh_cache
:   au BufNewFile,BufReadPost .vmh_cache let r=VmhCacheSyntaxColor()

:   au! BufNewFile,BufReadPost [1-9],[1-9][0-9],[1-9][0-9][0-9],[1-9][0-9]*[0-9][0-9]
:   au BufNewFile,BufReadPost [1-9],[1-9][0-9],[1-9][0-9][0-9],[1-9][0-9]*[0-9][0-9] let r=MailSyntaxColor()
:   au! BufNewFile,BufReadPost draft.[1-9],draft.[1-9][0-9],draft.[1-9][0-9][0-9],draft.[1-9][0-9]*[0-9][0-9]
:   au BufNewFile,BufReadPost draft.[1-9],draft.[1-9][0-9],draft.[1-9][0-9][0-9],draft.[1-9][0-9]*[0-9][0-9] let r=MailSyntaxColor()
:endif

:perl { require "vmh.pl"; }
